<%@ Page Language="C#" AutoEventWireup="False" Inherits="System.Web.UI.Page" %>
<%@ Import Namespace="System.Linq" %>
<%@ Import Namespace="EPiServer.Data.Dynamic" %>
<%@ Import Namespace="System.Reflection" %>

<!DOCTYPE html>
    <script runat="server">
       
        public void UpgradeFix(object sender, EventArgs e)
        {           
            foreach (var storeDefinition in StoreDefinition.GetAll())
            {
                try
                {
                    var type = TypeResolver.GetType(storeDefinition.StoreName);
                    if (type != null)
                    {
                        Response.Write("Remapping: " + storeDefinition.StoreName + "<br/>");

                        storeDefinition.Remap(type);
                        storeDefinition.CommitChanges();

                        Response.Write("Remapped: " + storeDefinition.StoreName + "<br/><br/>");
                    }
                    else
                    {
                        EPiServer.Data.Dynamic.Providers.DataStoreProvider.CreateInstance().SaveStoreDefinition(storeDefinition);

                    }
                }
                catch (NullReferenceException ex)
                {
                    Console.WriteLine(ex);
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex);
                }
            }
        }

    </script>
    <html>
    <body>
        <form runat="server">
            <p>Remember to back up your database before running this patch</p>
            <asp:Button runat="server" Text="Remap Stores" OnClick="UpgradeFix" />
        </form>
    </body>
</html>
